/**
 *
 * \file     kml_error_code.h
 * \brief    kmath lib API error codes
 * \authoers Toshiyuki Imamura (TI)
 * \date     2015/03/10 (NT)
 * 
 * (c) Copyright 2014 RIKEN. All rights reserved.
 */

#ifndef __kml_error_code_h__
#define __kml_error_code_h__


/* API level error codes */

#define E_None                        0
#define E_SolveFail                 (-1)
#define E_NoInput                   (-2)
#define E_Fatal                     (-3)


/* plugin level error codes */

#define EP_None                       0
#define EP_SolveFail                (-100)
#define EP_FatalInit                (-101)
#define EP_FatalShutdown            (-102)
#define EP_FatalToInternal          (-103)
#define EP_FatalToStandard          (-104)
#define EP_FatalRealloc             (-105)
#define EP_FatalReuse               (-106)
#define EP_FatalSolve               (-107)


/* plugin I/F level error codes */

#define EI_None                       0
#define EI_ParamNotFound            (-200)
#define EI_FatalGetParam            (-201)


#endif
