/**
 *
 * \file     kml_hash_table.h
 * \brief    hash table routines
 * \authoers Toshiyuki Imamura (TI)
 * \date     2014/12/24 (NT)
 * 
 * (c) Copyright 2014 RIKEN. All rights reserved.
 */

#ifndef __kml_hash_table_h__
#define __kml_hash_table_h__

#define HASH_SIZE  37

typedef struct _kml_list {

  char* name;
  char* value;
  struct _kml_list* next;

} kml_list;

typedef struct _kml_keys {

  char key[32];
  struct _kml_keys* next;

} kml_keys;

void        kml_hash_table_init (kml_list* hash_table []);
void        kml_hash_table_clear(kml_list* hash_table []);
void        kml_hash_table_set  (kml_list* hash_table [], 
								 const char* key, const char *value);
const char* kml_hash_table_get  (kml_list* hash_table [], const char *key);
void        kml_hash_table_erase(kml_list* hash_table [], const char* key);

kml_keys*   kml_hash_table_enum_keys(kml_list* hash_table []);
void        kml_hash_table_free_keys(kml_keys* keys);

#endif // !__kml_hash_table_h__
