program test

  use kmath_lib_mod
  use kmath_plugin_template_mod
  use mpi

  implicit none

#include <finclude/petscmatdef.h>

  integer :: ierr
  type(s_context) :: h
  Mat :: V1, V2, V3, V4, V5, V6, V7

  V1 = 1
  V2 = 2
  V3 = 3
  V4 = 4
  V5 = 5
  V6 = 6
  V7 = 7

  call MPI_Init(ierr)

  !TEST 1
  write(6,*) "---------- Create (1)"
  call KMATH_Create(h, MPI_COMM_WORLD, ierr)

  write(6,*) "------ SetPlugin"
  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Template, ierr)

  write(6,*) "------ Solve 1"
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V3, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Solve 2"
  call KMATH_Set_Parameter(h, 'A', V3, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V4, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "---------- Destroy (1)"
  call KMATH_Destroy(h, ierr)

  write(6,*) ""

  !TEST 2
  write(6,*) "---------- Create (2)"
  call KMATH_Create(h, MPI_COMM_WORLD, ierr)

  write(6,*) "------ SetPlugin"
  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Template, ierr)

  write(6,*) "------ Solve 1"
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V3, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Flush"
  call KMATH_Flush(h, ierr)

  write(6,*) "------ Solve 2"
  call KMATH_Set_Parameter(h, 'A', V3, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V4, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "---------- Destroy (2)"
  call KMATH_Destroy(h, ierr)

  write(6,*) ""

  !TEST 3
  write(6,*) "---------- Create (3)"
  call KMATH_Create(h, MPI_COMM_WORLD, ierr)

  write(6,*) "------ SetPlugin"
  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Template, ierr)

  write(6,*) "------ Solve 1"
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V3, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Solve 2"
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V4, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Solve 3"
  call KMATH_Set_Parameter(h, 'A', V3, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V4, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "---------- Destroy (3)"
  call KMATH_Destroy(h, ierr)

  write(6,*) ""

  !TEST 4
  write(6,*) "---------- Create (4)"
  call KMATH_Create(h, MPI_COMM_WORLD, ierr)

  write(6,*) "------ SetPlugin"
  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Template, ierr)

  write(6,*) "------ Solve 1"
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V3, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Solve 2"
  call KMATH_Set_Parameter(h, 'A', V4, ierr)
  call KMATH_Set_Parameter(h, 'B', V5, ierr)
  call KMATH_Set_Parameter(h, 'X', V6, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "------ Solve 3"
  call KMATH_Set_Parameter(h, 'A', V3, ierr)
  call KMATH_Set_Parameter(h, 'B', V6, ierr)
  call KMATH_Set_Parameter(h, 'X', V7, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "---------- Destroy (3)"
  call KMATH_Destroy(h, ierr)

  call MPI_Finalize(ierr)

  stop

end program test
