program test

  use kmath_lib_mod
  use kmath_plugin_template_mod
  use mpi

  implicit none

#include <finclude/petscmatdef.h>

  integer :: ierr, rank
  type(s_context) :: h
  Mat :: V1, V2, V3, V4

  V1 = 1
  V2 = 2
  V3 = 3
  V4 = 4

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierr)

  write(6,*) "---------- Create", rank
  call KMATH_Create(h, MPI_COMM_WORLD, ierr)

  write(6,*) "------ SetPlugin", rank
  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Template, ierr)

  write(6,*) "------ Solve", rank
  call KMATH_Set_Parameter(h, 'A', V1, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V3, ierr)
  call KMATH_Solve(h, ierr)

  !write(6,*) "------ Set Param", rank
  !call KMATH_Set_Parameter(h, 'P1', 0, ierr)

  write(6,*) "------ Solve", rank
  call KMATH_Set_Parameter(h, 'A', V3, ierr)
  call KMATH_Set_Parameter(h, 'B', V2, ierr)
  call KMATH_Set_Parameter(h, 'X', V4, ierr)
  call KMATH_Solve(h, ierr)

  write(6,*) "---------- Destroy", rank
  call KMATH_Destroy(h, ierr)

  call MPI_Finalize(ierr)

  stop

end program test
